/* tde91r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

int main(void)
{
    /* Builtin functions */
    double exp(double);

    /* Local variables */
    extern int de91r_c(U_fp, U_fp, int *, float *, float *, float *,
                       float *, float *, float *, float *, float *,
                       float *, int *);
    static float hmin;
    static int ierr;
    static float a, b, c__;
    extern int f_c();
    static float h__;
    static int m;
    static float p, r__[81], y[4], t1, t2, t3, y1, y2, y3, y4, dd, ff, gg;
    extern int fj_c();
    static int ih;
    static float qq, xk, xn, yn[4], eps;

    m = 4;
    xn = 0.f;
    yn[0] = 1.f;
    yn[1] = 1.f;
    yn[2] = 1.f;
    yn[3] = 1.f;
    hmin = 1e-10f;
    eps = .01f;
    p = 100.f;
    xk = 20.f;
/* BCEHE TOHOO PEEH CCTEM: */
    y4 = (float)exp((float)(xk * -.1f));
    t1 = (float)exp((float)(-xk));
    y3 = t1 * -10.111111111111111f + y4 * 11.111111111111111f;
    t2 = (float)exp((float)(xk * -1e3f));
    a = -.10121232343454566f;
    b = .10112122323343446f;
    c__ = 1.f - a - b;
    y2 = c__ * t2 + a * t1 + b * y4;
    t3 = (float)exp((float)(xk * -1e4f));
    dd = c__ / 90.f;
    ff = (a * 100.f + 101.11111111111111f) / 9999.f;
    gg = (b * 100.f - 111.11111111111111f + 1.f) / 9999.9f;
    qq = 1.f - dd - ff - gg;
    y1 = qq * t3 + dd * t2 + ff * t1 + gg * y4;

    printf("\n %16.7e %16.7e \n", y1, y2);
    printf("\n %16.7e %16.7e \n", y3, y4);
    ih = 0;
L10:
    ++ih;
    h__ = .01f;
    de91r_c((U_fp)f_c, (U_fp)fj_c, &m, &xn, yn, &xk, &hmin, &eps, &p, &h__, y,
            r__, &ierr);

    printf("\n %7.1e \n", eps);
    printf("\n %16.7e %16.7e ", y[0], y[1]);
    printf("\n %16.7e %16.7e \n", y[2], y[3]);
    printf("\n %16.7e \n", h__);
    eps *= .1f;
    if (ih < 3) {
        goto L10;
    }
    return 0;
} /* main */

int f_c(float *x, float *y, float *dy, int *m)
{
    /* Parameter adjustments */
    --dy;
    --y;

    /* Function Body */
    dy[1] = y[1] * -1e4f + y[2] * 100.f - y[3] * 10.f + y[4];
    dy[2] = y[2] * -1e3f + y[3] * 10.f - y[4] * 10.f;
    dy[3] = -y[3] + y[4] * 10.f;
    dy[4] = y[4] * -.1f;
    return 0;
} /* f_c */

int fj_c(float *x, float *y, float *df, int *m)
{
#define df_ref(a_1,a_2) df[(a_2)*4 + a_1]

    /* Parameter adjustments */
    df -= 5;
    --y;

    /* Function Body */
    df_ref(1, 1) = -1e4f;
    df_ref(1, 2) = 100.f;
    df_ref(1, 3) = -10.f;
    df_ref(1, 4) = 1.f;
    df_ref(2, 1) = 0.f;
    df_ref(2, 2) = -1e3f;
    df_ref(2, 3) = 10.f;
    df_ref(2, 4) = -10.f;
    df_ref(3, 1) = 0.f;
    df_ref(3, 2) = 0.f;
    df_ref(3, 3) = -1.f;
    df_ref(3, 4) = 10.f;
    df_ref(4, 1) = 0.f;
    df_ref(4, 2) = 0.f;
    df_ref(4, 3) = 0.f;
    df_ref(4, 4) = -.1f;
    return 0;
} /* fj_c */

#undef df_ref
